- NAME
- SYNOPSIS
- FUNCTION DESCRIPTIONS

- AdaptiveThresholdImage
- AddNoiseImage
- BlurImage
- ChannelThresholdImage
- DespeckleImage
- EdgeImage
- EmbossImage
- EnhanceImage
- GaussianBlurImage
- MedianFilterImage
- MotionBlurImage
- RandomChannelThresholdImage
- ReduceNoiseImage
- ShadeImage
- SharpenImage
- SpreadImage
- ThresholdImage
- UnsharpMaskImage

# NAME

effect - Image effects methods

# SYNOPSIS

Image * AdaptiveThresholdImage( Image *image, const unsigned long width, const unsigned long height, const unsigned long unsigned long, ExceptionInfo *exception );

Image * AddNoiseImage( const Image *image, const NoiseType noise_type, ExceptionInfo *exception );

Image * BlurImage( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

unsigned int ChannelThresholdImage( Image *image, const char *threshold );

Image * DespeckleImage( const Image *image, ExceptionInfo *exception );

Image * EdgeImage( const Image *image, const double radius, ExceptionInfo *exception );

Image * EmbossImage( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

Image * EnhanceImage( const Image *image, ExceptionInfo *exception );

Image * GaussianBlurImage( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

Image * MedianFilterImage( const Image *image, const double radius, ExceptionInfo *exception );

Image * MotionBlurImage( const Image *image, const double radius, const double sigma, const double angle, ExceptionInfo *exception );

unsigned int RandomChannelThresholdImage( Image *image, const char *channel, const char *thresholds, ExceptionInfo *exception );

Image * ReduceNoiseImage( const Image *image, const double radius, ExceptionInfo *exception );

Image * ShadeImage( const Image *image, const unsigned int gray, double azimuth, double elevation, ExceptionInfo *exception );

Image * SharpenImage( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

Image * SpreadImage( const Image *image, const unsigned int radius, ExceptionInfo *exception );

unsigned int ThresholdImage( Image *image, const double threshold );

Image * UnsharpMaskImage( const Image *image, const double radius, const double sigma, const double amount, const double threshold, ExceptionInfo *exception );

# FUNCTION DESCRIPTIONS

## AdaptiveThresholdImage

> AdaptiveThresholdImage() selects an individual threshold for each pixel based on the range of intensity values in its local neighborhood. This allows for thresholding of an image whose global intensity histogram doesn't contain distinctive peaks.

The format of the AdaptiveThresholdImage method is:

> Image *AdaptiveThresholdImage ( Image *image, const unsigned long width, const unsigned long height, const unsigned long unsigned long, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

width:

  The width of the local neighborhood.

height:

  The height of the local neighborhood.

offset:

  The mean offset.

exception:

  Return any errors or warnings in this structure.

## AddNoiseImage

> AddNoiseImage() adds random noise to the image.

The format of the AddNoiseImage method is:

> Image *AddNoiseImage ( const Image *image, const NoiseType noise_type, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

noise_type:

  The type of noise: Uniform, Gaussian, Multiplicative, Impulse, Laplacian, or Poisson.

exception:

  Return any errors or warnings in this structure.

## BlurImage

> BlurImage() blurs an image. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, the radius should be larger than sigma. Use a radius of 0 and BlurImage ( ) selects a suitable radius for you.

The format of the BlurImage method is:

> Image *BlurImage ( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

A description of each parameter follows:

radius:

  The radius of the Gaussian, in pixels, not counting the center pixel.

sigma:

  The standard deviation of the Gaussian, in pixels.

exception:

  Return any errors or warnings in this structure.

## ChannelThresholdImage

> ChannelThresholdImage() changes the value of individual pixels based on the intensity of each pixel channel. The result is a high-contrast image.

The format of the ChannelThresholdImage method is:

> unsigned int ChannelThresholdImage ( Image *image, const char *threshold );

A description of each parameter follows:

image:

  The image.

threshold:

  define the threshold values.

## DespeckleImage

`Despeckle()` reduces the speckle noise in an image while perserving the edges of the original image.

The format of the DespeckleImage method is:

> Image *DespeckleImage ( const Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

exception:

  Return any errors or warnings in this structure.

## EdgeImage

> EdgeImage() finds edges in an image. Radius defines the radius of the convolution filter. Use a radius of 0 and Edge ( ) selects a suitable radius for you.

The format of the EdgeImage method is:

> Image *EdgeImage ( const Image *image, const double radius, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  the radius of the pixel neighborhood.

exception:

  Return any errors or warnings in this structure.

## EmbossImage

> EmbossImage() returns a grayscale image with a three-dimensional effect. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, radius should be larger than sigma. Use a radius of 0 and Emboss ( ) selects a suitable radius for you.

The format of the EmbossImage method is:

> Image *EmbossImage ( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  the radius of the pixel neighborhood.

sigma:

  The standard deviation of the Gaussian, in pixels.

exception:

  Return any errors or warnings in this structure.

## EnhanceImage

> EnhanceImage() applies a digital filter that improves the quality of a noisy image.

The format of the EnhanceImage method is:

> Image *EnhanceImage ( const Image *image, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

exception:

  Return any errors or warnings in this structure.

## GaussianBlurImage

> GaussianBlurImage() blurs an image. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, the radius should be larger than sigma. Use a radius of 0 and GaussianBlurImage ( ) selects a suitable radius for you

The format of the BlurImage method is:

> Image *GaussianBlurImage ( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

A description of each parameter follows:

blur_image:

  Method GaussianBlurImage returns a pointer to the image after it is blur. A null image is returned if there is a memory shortage.

radius:

  the radius of the Gaussian, in pixels, not counting the center pixel.

sigma:

  the standard deviation of the Gaussian, in pixels.

exception:

  Return any errors or warnings in this structure.

## MedianFilterImage

> MedianFilterImage() applies a digital filter that improves the quality of a noisy image. Each pixel is replaced by the median in a set of neighboring pixels as defined by radius.

The algorithm was contributed by Mike Edmonds and implements an insertion sort for selecting median color-channel values. For more on this algorithm see ``Skip Lists: A probabilistic Alternative to Balanced Trees'' by William Pugh in the June 1990 of Communications of the ACM.

The format of the MedianFilterImage method is:

> Image *MedianFilterImage ( const Image *image, const double radius, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  The radius of the pixel neighborhood.

exception:

  Return any errors or warnings in this structure.

## MotionBlurImage

> MotionBlurImage() simulates motion blur. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, radius should be larger than sigma. Use a radius of 0 and MotionBlurImage ( ) selects a suitable radius for you. Angle gives the angle of the blurring motion.

Andrew Protano contributed this effect.

The format of the MotionBlurImage method is:

> Image *MotionBlurImage ( const Image *image, const double radius, const double sigma, const double angle, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  The radius of the Gaussian, in pixels, not counting the center pixel.

sigma:

  The standard deviation of the Gaussian, in pixels.

angle:

  Apply the effect along this angle.

exception:

  Return any errors or warnings in this structure.

## RandomChannelThresholdImage

> RandomChannelThresholdImage() changes the value of individual pixels based on the intensity of each pixel compared to a random threshold. The result is a low-contrast, two color image.

The format of the RandomChannelThresholdImage method is:

> unsigned int RandomChannelThresholdImage ( Image *image, const char *channel, const char *thresholds, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

channel:

  The channel or channels to be thresholded.

thresholds:

  a geometry string containing LOWxHIGH thresholds. If the string contains 2x2, 3x3, or 4x4, then an ordered dither of order 2, 3, or 4 will be performed instead.

exception:

  Return any errors or warnings in this structure.

## ReduceNoiseImage

> ReduceNoiseImage() smooths the contours of an image while still preserving edge information. The algorithm works by replacing each pixel with its neighbor closest in value. A neighbor is defined by radius. Use a radius of 0 and ReduceNoise ( ) selects a suitable radius for you.

The format of the ReduceNoiseImage method is:

> Image *ReduceNoiseImage ( const Image *image, const double radius, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  The radius of the pixel neighborhood.

exception:

  Return any errors or warnings in this structure.

## ShadeImage

> ShadeImage() shines a distant light on an image to create a three-dimensional effect. You control the positioning of the light with azimuth and elevation; azimuth is measured in degrees off the x axis and elevation is measured in pixels above the Z axis.

The format of the ShadeImage method is:

> Image *ShadeImage ( const Image *image, const unsigned int gray, double azimuth, double elevation, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

gray:

  A value other than zero shades the intensity of each pixel.

azimuth, elevation:

  Define the light source direction.

exception:

  Return any errors or warnings in this structure.

## SharpenImage

> SharpenImage() sharpens an image. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, radius should be larger than sigma. Use a radius of 0 and SharpenImage ( ) selects a suitable radius for you.

The format of the SharpenImage method is:

> Image *SharpenImage ( const Image *image, const double radius, const double sigma, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  The radius of the Gaussian, in pixels, not counting the center pixel.

sigma:

  The standard deviation of the Laplacian, in pixels.

exception:

  Return any errors or warnings in this structure.

## SpreadImage

> SpreadImage() is a special effects method that randomly displaces each pixel in a block defined by the radius parameter.

The format of the SpreadImage method is:

> Image *SpreadImage ( const Image *image, const unsigned int radius, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  Choose a random pixel in a neighborhood of this extent.

exception:

  Return any errors or warnings in this structure.

## ThresholdImage

> ThresholdImage() changes the value of individual pixels based on the intensity of each pixel compared to threshold. The result is a high-contrast, two color image.

The format of the ThresholdImage method is:

> unsigned int ThresholdImage ( Image *image, const double threshold );

A description of each parameter follows:

image:

  The image.

threshold:

  Define the threshold value

## UnsharpMaskImage

> UnsharpMaskImage() sharpens an image. We convolve the image with a Gaussian operator of the given radius and standard deviation ( sigma ) . For reasonable results, radius should be larger than sigma. Use a radius of 0 and UnsharpMaskImage ( ) selects a suitable radius for you.

The format of the UnsharpMaskImage method is:

> Image *UnsharpMaskImage ( const Image *image, const double radius, const double sigma, const double amount, const double threshold, ExceptionInfo *exception );

A description of each parameter follows:

image:

  The image.

radius:

  The radius of the Gaussian, in pixels, not counting the center pixel.

sigma:

  The standard deviation of the Gaussian, in pixels.

amount:

  The percentage of the difference between the original and the blur image that is added back into the original.

threshold:

  The threshold in pixels needed to apply the diffence amount.

exception:

  Return any errors or warnings in this structure.